# CreoleSQLExecTask

Extends \CreoleTask

Executes a series of SQL statements on a database using Creole.

Statements can either be read in from a text file using the src attribute or from between the enclosing SQL tags.

Multiple statements can be provided, separated by semicolons (or the defined delimiter). Individual lines within the statements can be commented using either --, // or REM at the start of the line.

The autocommit attribute specifies whether auto-commit should be turned on or off whilst executing the statements. If auto-commit is turned on each statement will be executed and committed. If it is turned off the statements will all be executed as one transaction.

The onerror attribute specifies how to proceed when an error occurs during the execution of one of the statements. The possible values are: continue execution, only show the error; stop execution and commit transaction; and abort execution and transaction and fail task.

author | Hans Lellelid hans@xmpl.org (Phing)
author | Jeff Martin jeff@custommonkey.org (Ant)
author | Michael McCallum gholam@xtra.co.nz (Ant)
author | Tim Stephenson tim.stephenson@sybase.com (Ant)
package | phing.tasks.ext.creole
version | $Id: b0540d6f531fdc2a5103a09c92a54318ebdf8c0b $

### Methods

## Adds a set of files (nested fileset attribute).

    addFileset(\FileSet $set)

### Arguments

#### $set

`\FileSet`

## Set an inline SQL command to execute.

    addText( $sql)

NB: Properties are not expanded in this text.

### Arguments

#### $sql

``

## Creates a filterchain

    createFilterChain() : object

### Response

`object`

The created filterchain object

## Add a SQL transaction to execute

    createTransaction()

## Exec the sql statement.

    execSQL( $sql, null $out = null)

throws |

### Arguments

#### $sql

``

#### $out

`null`

## Creates a new Connection as using the driver, url, userid and password specified.

    getConnection() : \Connection

inherited

The calling method is responsible for closing the connection.

throws | if the UserId/Password/Url is not set or there is no suitable driver or the driver fails to load.

### Response

`\Connection`

the newly created connection.

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## getLoaderMap

    getLoaderMap() : array

inherited

### Response

`array`

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## Gets the password.

    getPassword() : string

inherited

### Response

`string`

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## Gets the url.

    getUrl() : string

inherited

### Response

`string`

## Gets the userId.

    getUserId() : string

inherited

### Response

`string`

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## Gets the autocommit.

    isAutocommit() : \Returns

inherited

### Response

`\Returns`

a boolean

## isCaching

    isCaching( $value)

inherited

### Arguments

#### $value

``

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## Perfrom this task

    perform()

inherited

throws |

## print any results in the statement.

    printResults(null $out = null)

### Arguments

#### $out

`null`

## read in lines and execute them

    runStatements(\Reader $reader, null $out = null)

throws |

### Arguments

#### $reader

`\Reader`

#### $out

`null`

## whether output should be appended to or overwrite an existing file. Defaults to false.

    setAppend( $append)

### Arguments

#### $append

``

## Auto commit flag for database connection; optional, default false.

    setAutocommit(boolean $autocommit)

inherited

### Arguments

#### $autocommit

`boolean`

The autocommit to set

## Caching loaders / driver. This is to avoid getting an OutOfMemoryError when calling this task multiple times in a row; default: true

    setCaching(boolean $enable)

inherited

### Arguments

#### $enable

`boolean`

## Set the statement delimiter.

    setDelimiter( $delimiter)

For example, set this to "go" and delimitertype to "ROW" for Sybase ASE or MS SQL Server.

### Arguments

#### $delimiter

``

## Set the Delimiter type for this sql task. The delimiter type takes two values - normal and row. Normal means that any occurrence of the delimiter terminate the SQL command whereas with row, only a line containing just the delimiter is recognized as the end of the command.

    setDelimiterType(string $delimiterType)

### Arguments

#### $delimiterType

`string`

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## Set the Creole driver to be used.

    setDriver(string $driver)

inherited

### Arguments

#### $driver

`string`

driver class name

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Action to perform when statement fails: continue, stop, or abort optional; default &quot;abort&quot;

    setOnerror( $action)

### Arguments

#### $action

``

## Set the output file; optional, defaults to the console.

    setOutput(\PhingFile $output)

### Arguments

#### $output

`\PhingFile`

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## Sets the password; required.

    setPassword(string $password)

inherited

### Arguments

#### $password

`string`

The password to set

## Set the print flag.

    setPrint(boolean $print)

### Arguments

#### $print

`boolean`

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Print headers for result sets from the statements; optional, default true.

    setShowheaders(boolean $showheaders)

### Arguments

#### $showheaders

`boolean`

## Set the name of the SQL file to be run.

    setSrc(\PhingFile $srcFile)

Required unless statements are enclosed in the build file

### Arguments

#### $srcFile

`\PhingFile`

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

## Sets the database connection URL; required.

    setUrl(string $url)

inherited

### Arguments

#### $url

`string`

## Set the user name for the connection; required.

    setUserid(string $userId)

inherited

### Arguments

#### $userId

`string`

## Sets the version string, execute task only if rdbms version match; optional.

    setVersion(string $version)

inherited

### Arguments

#### $version

`string`

### Constants

## DELIM_ROW

    DELIM_ROW

## DELIM_NORMAL

    DELIM_NORMAL

### Properties

## goodSql

    goodSql :

### Type(s)

``

## totalSql

    totalSql :

### Type(s)

``

## Database connection

    conn :

### Type(s)

``

## files to load

    filesets :

### Type(s)

``

## all filterchains objects assigned to this task

    filterChains :

### Type(s)

``

## SQL statement

    statement :

### Type(s)

``

## SQL input file

    srcFile :

### Type(s)

``

## SQL input command

    sqlCommand :

### Type(s)

``

## SQL transactions to perform

    transactions :

### Type(s)

``

## SQL Statement delimiter

    delimiter :

### Type(s)

``

## The delimiter type indicating whether the delimiter will only be recognized on a line by itself

    delimiterType :

### Type(s)

``

## Print SQL results.

    print :

### Type(s)

``

## Print header columns.

    showheaders :

### Type(s)

``

## Results Output file.

    output :

### Type(s)

``

## Action to perform if an error is found

    onError :

### Type(s)

``

## Encoding to use when reading SQL statements from a file

    encoding :

### Type(s)

``

## Append to an existing file or overwrite it?

    append :

### Type(s)

``

## Used for caching loaders / driver. This is to avoid getting an OutOfMemoryError when calling this task multiple times in a row.

    loaderMap :

inherited static

NOT IMPLEMENTED YET

### Type(s)

``

## caching

    caching :

inherited

### Type(s)

``

## Autocommit flag. Default value is false

    autocommit :

inherited

### Type(s)

``

## [optional] Classpath to Creole driver to use.

    driver :

inherited

param |

### Type(s)

``

## DB url.

    url :

inherited

### Type(s)

``

## User name.

    userId :

inherited

### Type(s)

``

## Password

    password :

inherited

### Type(s)

``

## RDBMS Product needed for this SQL.

    rdbms :

inherited

### Type(s)

``

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`